#!/usr/bin/env python

import re
from collections import OrderedDict

def readFasta_dict(infile_fasta_fn):
    Infile = open(infile_fasta_fn, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            seqDictFN[Name] += Line
    Infile.close()
    return seqDictFN

def sort_by_Chr_Start(recsFN):
    recsListFN = []
    for name, seq in recsFN.items():
        #print(name)
        match = re.search(">([^:]+):([^\-]+)-(.*)$", name)
        chr = match.group(1)
        start = match.group(2)
        end = match.group(3)
        recsListFN.append([chr, int(start), int(end), seq])
    sorted_recsListFN = sorted(recsListFN, key=lambda x: (x[0], x[1]))
    return sorted_recsListFN

def list2OrderedDict(recsListFN):
    seqDictFN  = OrderedDict()
    for rec in recsList:
        chr = rec[0]
        start = rec[1]
        end = rec[2]
        seq = rec[3]
        nameLine = ">" + chr + ":" + str(start) + "-" + str(end)
        seqDictFN[nameLine] = seq
    return seqDictFN

######## Main program
infaile_fasta = "fastafile.txt"
recs = readFasta_dict(infaile_fasta)
recsList = sort_by_Chr_Start(recs)
recs = list2OrderedDict(recsList)
out = open("out.txt", "w")
for name , seq in recs.items():
    out.write(name + "\n" + seq + "\n")
out.close()